#include <qapplication.h>
#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <string.h>
#include <qstring.h>
#include <qlineedit.h>
#include <qtranslator.h>
#include <qtextcodec.h>

#include "mainmenu.h"
#include "letForm.h"
#include "statsdialog.h"

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);
    QTranslator appTranslator;
    appTranslator.load(QString("LET_") + QTextCodec::locale(),
		       qApp->applicationDirPath());
    app.installTranslator(&appTranslator);
    QTranslator qtTranslator;
    qtTranslator.load(QString("qt_") + QTextCodec::locale(),
		      qApp->applicationDirPath());
    app.installTranslator(&qtTranslator);
    mainMenu *dialog = new mainMenu;
    app.setMainWidget(dialog);
    dialog->show();  
   return app.exec();
}
