/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include <qapplication.h>
#include <qsettings.h>
#include <qcombobox.h>
#include <iostream>
    using namespace std;

void optionsForm::changeScheme()
{
    disconnect( showExpOption, SIGNAL( stateChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( minX, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( maxX, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( minA, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( maxA, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( minY, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( maxY, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    
    disconnect( minX_2, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( maxX_2, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( minA_2, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( maxA_2, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( minY_2, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( maxY_2, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    
    disconnect( minA_3, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( maxA_3, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( minB_3, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( maxB_3, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( addBox, SIGNAL( stateChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( subBox, SIGNAL( stateChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( multBox, SIGNAL( stateChanged(int) ), this, SLOT( customScheme() ) );
    disconnect( divBox, SIGNAL( stateChanged(int) ), this, SLOT( customScheme() ) );
    
    int comboThing = difficultyCombo->currentItem();
    switch(comboThing){
    case 0:
	    minX->setValue(1);
	    maxX->setValue(10);
	    minA->setValue(1);
	    maxA->setValue(1);
	    minY->setValue(0);
	    maxY->setValue(10);
	    showExpOption->setChecked(true);
	    
	    minX_2->setValue(1);
	    maxX_2->setValue(5);
	    minA_2->setValue(1);
	    maxA_2->setValue(3);
	    minY_2->setValue(0);
	    maxY_2->setValue(0);
	    
	    minA_3->setValue(1);
	    maxA_3->setValue(10);
	    minB_3->setValue(1);
	    maxB_3->setValue(10);
	    addBox->setChecked(true);
	    subBox->setChecked(true);
	    multBox->setChecked(false);
	    divBox->setChecked(false);
	    break;
	case 1:
	    minX->setValue(1);
	    maxX->setValue(5);
	    minA->setValue(1);
	    maxA->setValue(10);
	    minY->setValue(-20);
	    maxY->setValue(20);
	    showExpOption->setChecked(true);
	    
	    minX_2->setValue(1);
	    maxX_2->setValue(10);
	    minA_2->setValue(1);
	    maxA_2->setValue(5);
	    minY_2->setValue(0);
	    maxY_2->setValue(10);
	    
	    minA_3->setValue(1);
	    maxA_3->setValue(20);
	    minB_3->setValue(1);
	    maxB_3->setValue(10);
	    addBox->setChecked(true);
	    subBox->setChecked(true);
	    multBox->setChecked(false);
	    divBox->setChecked(false);
	    break;
	case 2:
	    minX->setValue(-20);
	    maxX->setValue(20);
	    minA->setValue(-10);
	    maxA->setValue(10);
	    minY->setValue(-20);
	    maxY->setValue(20);
	    showExpOption->setChecked(true);
	    
	    minX_2->setValue(-10);
	    maxX_2->setValue(10);
	    minA_2->setValue(-5);
	    maxA_2->setValue(5);
	    minY_2->setValue(-5);
	    maxY_2->setValue(5);
	    
	    minA_3->setValue(1);
	    maxA_3->setValue(20);
	    minB_3->setValue(1);
	    maxB_3->setValue(20);
	    addBox->setChecked(true);
	    subBox->setChecked(true);
	    multBox->setChecked(true);
	    divBox->setChecked(false);
	    break;
	case 3:
	    minX->setValue(-20);
	    maxX->setValue(20);
	    minA->setValue(-20);
	    maxA->setValue(20);
	    minY->setValue(-20);
	    maxY->setValue(20);
	    showExpOption->setChecked(false);
	    
	    minX_2->setValue(-10);
	    maxX_2->setValue(10);
	    minA_2->setValue(-5);
	    maxA_2->setValue(5);
	    minY_2->setValue(-20);
	    maxY_2->setValue(20);
	    
	    minA_3->setValue(1);
	    maxA_3->setValue(50);
	    minB_3->setValue(-20);
	    maxB_3->setValue(20);
	    addBox->setChecked(true);
	    subBox->setChecked(true);
	    multBox->setChecked(true);
	    divBox->setChecked(true);
	    break;
	case 4:
	    minX->setValue(-100);
	    maxX->setValue(100);
	    minA->setValue(-100);
	    maxA->setValue(100);
	    minY->setValue(-100);
	    maxY->setValue(100);
	    showExpOption->setChecked(false);
	    
	    minX_2->setValue(-20);
	    maxX_2->setValue(20);
	    minA_2->setValue(-20);
	    maxA_2->setValue(20);
	    minY_2->setValue(-20);
	    maxY_2->setValue(20);
	    
	    minA_3->setValue(-100);
	    maxA_3->setValue(100);
	    minB_3->setValue(-100);
	    maxB_3->setValue(100);
	    addBox->setChecked(true);
	    subBox->setChecked(true);
	    multBox->setChecked(true);
	    divBox->setChecked(true);
	    break;
	case 5:
	    minX->setValue(0);
	    maxX->setValue(0);
	    minA->setValue(0);
	    maxA->setValue(0);
	    minY->setValue(0);
	    maxY->setValue(0);
	    showExpOption->setChecked(false);
	    
	    minX_2->setValue(0);
	    maxX_2->setValue(0);
	    minA_2->setValue(0);
	    maxA_2->setValue(0);
	    minY_2->setValue(0);
	    maxY_2->setValue(0);
	    
	    minA_3->setValue(0);
	    maxA_3->setValue(0);
	    minB_3->setValue(0);
	    maxB_3->setValue(0);
	    addBox->setChecked(false);
	    subBox->setChecked(false);
	    multBox->setChecked(false);
	    divBox->setChecked(false);
	    break;
	default:
	    minX->setValue(1);
	    maxX->setValue(10);
	    minA->setValue(1);
	    maxA->setValue(10);
	    minY->setValue(-20);
	    maxY->setValue(20);
	    showExpOption->setChecked(false);
	    
	    minX_2->setValue(1);
	    maxX_2->setValue(10);
	    minA_2->setValue(1);
	    maxA_2->setValue(5);
	    minY_2->setValue(0);
	    maxY_2->setValue(10);
	    
	    minA_3->setValue(1);
	    maxA_3->setValue(20);
	    minB_3->setValue(1);
	    maxB_3->setValue(10);
	    addBox->setChecked(true);
	    subBox->setChecked(true);
	    multBox->setChecked(false);
	    divBox->setChecked(false);
	}
    connect( showExpOption, SIGNAL( stateChanged(int) ), this, SLOT( customScheme() ) );
    connect( minX, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( maxX, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( minA, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( maxA, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( minY, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( maxY, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );

    connect( minX_2, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( maxX_2, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( minA_2, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( maxA_2, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( minY_2, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( maxY_2, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    
    connect( minA_3, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( maxA_3, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( minB_3, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( maxB_3, SIGNAL( valueChanged(int) ), this, SLOT( customScheme() ) );
    connect( addBox, SIGNAL( stateChanged(int) ), this, SLOT( customScheme() ) );
    connect( subBox, SIGNAL( stateChanged(int) ), this, SLOT( customScheme() ) );
    connect( multBox, SIGNAL( stateChanged(int) ), this, SLOT( customScheme() ) );
    connect( divBox, SIGNAL( stateChanged(int) ), this, SLOT( customScheme() ) );
    }


void optionsForm::customScheme()
{
    difficultyCombo->setCurrentItem(5);
    
    minx=minX->value();
    maxx=maxX->value();
    miny=minY->value();
    maxy=maxY->value();
    mina=minA->value();
    maxa=maxA->value();
    minxs=minX_2->value();
    maxxs=maxX_2->value();
    minys=minY_2->value();
    maxys=maxY_2->value();
    minas=minA_2->value();
    maxas=maxA_2->value();
    minia=minA_3->value();
    maxia=maxA_3->value();
    minib=minB_3->value();
    maxib=maxB_3->value();
    
    if(minx>maxx){
	minX->setValue(maxx);
	maxX->setValue(minx);
    }
    if(miny>maxy){
	minY->setValue(maxy);
	maxY->setValue(miny);
    }
    if(mina>maxa){
	minA->setValue(maxa);
	maxA->setValue(mina);
    }
    
    if(minxs>maxxs){
	minX_2->setValue(maxxs);
	maxX_2->setValue(minxs);
    }
    if(minys>maxys){
	minY_2->setValue(maxys);
	maxY_2->setValue(minys);
    }
    if(minas>maxas){
	minA_2->setValue(maxas);
	maxA_2->setValue(minas);
    }
    if(minia>maxia){
	minA_3->setValue(maxia);
	maxA_3->setValue(minia);
    }
    if(minib>maxib){
	minB_3->setValue(maxib);
	maxB_3->setValue(minib);
    }
}


void optionsForm::saveScheme()
{
    minx=minX->value();
    maxx=maxX->value();
    miny=minY->value();
    maxy=maxY->value();
    mina=minA->value();
    maxa=maxA->value();
    showexp=showExpOption->isChecked();
    minxs=minX_2->value();
    maxxs=maxX_2->value();
    minys=minY_2->value();
    maxys=maxY_2->value();
    minas=minA_2->value();
    maxas=maxA_2->value();
    minia=minA_3->value();
    maxia=maxA_3->value();
    minib=minB_3->value();
    maxib=maxB_3->value();
    addop=addBox->isChecked();
    subop=subBox->isChecked();
    multop=multBox->isChecked();
    divop=divBox->isChecked();
    
    QSettings settings;
    settings.setPath("corfizz.com", "Maths Tester");
    settings.beginGroup("/Settings");
    settings.writeEntry("/Settings/minX", minx);
    settings.writeEntry("/Settings/minY", miny);
    settings.writeEntry("/Settings/minA", mina);
    settings.writeEntry("/Settings/maxX", maxx);
    settings.writeEntry("/Settings/maxY", maxy);
    settings.writeEntry("/Settings/maxA", maxa);
    settings.writeEntry("/Settings/showExp", showexp);
    settings.writeEntry("/Settings/minX2", minxs);
    settings.writeEntry("/Settings/minY2", minys);
    settings.writeEntry("/Settings/minA2", minas);
    settings.writeEntry("/Settings/maxX2", maxxs);
    settings.writeEntry("/Settings/maxY2", maxys);
    settings.writeEntry("/Settings/maxA2", maxas);
    settings.writeEntry("/Settings/minia", minia);
    settings.writeEntry("/Settings/maxia", maxia);
    settings.writeEntry("/Settings/minib", minib);
    settings.writeEntry("/Settings/maxib", maxib);
    settings.writeEntry("/Settings/addop", addop);
    settings.writeEntry("/Settings/subop", subop);
    settings.writeEntry("/Settings/multop", multop);
    settings.writeEntry("/Settings/divop", divop);
    settings.endGroup();
}

void optionsForm::init()
{
    QSettings settings;
    settings.setPath("corfizz.com", "Maths Tester");
    settings.beginGroup("/Settings");
    cout << "Loading settings" << endl;
    minX->setValue(settings.readNumEntry("/Settings/minX", minx));
    minY->setValue(settings.readNumEntry("/Settings/minY", miny));
    minA->setValue(settings.readNumEntry("/Settings/minA", mina));
    maxX->setValue(settings.readNumEntry("/Settings/maxX", maxx));
    maxA->setValue(settings.readNumEntry("/Settings/maxA", maxa));
    maxY->setValue(settings.readNumEntry("/Settings/maxY", maxy));
    bool showexp = settings.readBoolEntry("/Settings/showExp", showexp);
    minX_2->setValue(settings.readNumEntry("/Settings/minX2", minxs));
    minY_2->setValue(settings.readNumEntry("/Settings/minY2", minys));
    minA_2->setValue(settings.readNumEntry("/Settings/minA2", minas));
    maxX_2->setValue(settings.readNumEntry("/Settings/maxX2", maxxs));
    maxA_2->setValue(settings.readNumEntry("/Settings/maxA2", maxas));
    maxY_2->setValue(settings.readNumEntry("/Settings/maxY2", maxys));
    showExpOption->setChecked(showexp);
    minA_3->setValue(settings.readNumEntry("/Settings/minia", minia));
    minB_3->setValue(settings.readNumEntry("/Settings/minib", minib));
    maxB_3->setValue(settings.readNumEntry("/Settings/maxib", maxib));
    maxA_3->setValue(settings.readNumEntry("/Settings/maxia", maxia));
    
    int minx = settings.readNumEntry("/Settings/minX", minx);
    int miny = settings.readNumEntry("/Settings/minY", miny);
    int mina = settings.readNumEntry("/Settings/minA", mina);
    int maxx = settings.readNumEntry("/Settings/maxX", maxx);
    int maxy = settings.readNumEntry("/Settings/maxY", maxy);
    int maxa = settings.readNumEntry("/Settings/maxA", maxa);
	    
    int minxs = settings.readNumEntry("/Settings/minX2", minxs);
    int minys = settings.readNumEntry("/Settings/minY2", minys);
    int minas = settings.readNumEntry("/Settings/minA2", minas);
    int maxxs = settings.readNumEntry("/Settings/maxX2", maxxs);
    int maxys = settings.readNumEntry("/Settings/maxY2", maxys);
    int maxas = settings.readNumEntry("/Settings/maxA2", maxas);

    int minia = settings.readNumEntry("/Settings/minia", minia);
    int maxia = settings.readNumEntry("/Settings/maxia", maxia);
    int minib = settings.readNumEntry("/Settings/minib", minib);
    int maxib = settings.readNumEntry("/Settings/maxib", maxib);
    bool addop = settings.readBoolEntry("/Settings/addop", addop);
    bool subop = settings.readBoolEntry("/Settings/subop", subop);
    bool multop = settings.readBoolEntry("/Settings/multop", multop);
    bool divop = settings.readBoolEntry("/Settings/divop", divop);
    
    addBox->setChecked(addop);
    subBox->setChecked(subop);
    multBox->setChecked(multop);
    divBox->setChecked(divop);
    
// if(minx==miny==mina==maxx==maxa==maxy==0){
//	cout << "LET Things are 0" << endl;
//	minX->setValue(1);
//	    maxX->setValue(10);
//	    minA->setValue(1);
//	    maxA->setValue(10);
//	    minY->setValue(-20);
//	    maxY->setValue(20);
//	    showExpOption->setChecked(true);
//	    difficultyCombo->setCurrentItem(1);
//	}
//    if(minxs==minys==minas==maxxs==maxas==maxys==0){
//	minX_2->setValue(1);
//	    maxX_2->setValue(10);
//	    minA_2->setValue(1);
//	    maxA_2->setValue(5);
//	    minY_2->setValue(0);
//	    maxY_2->setValue(10);
//	    difficultyCombo->setCurrentItem(1);
//	}
//    if(minia==minib==maxia==maxib==0){
//	cout << "All things 0" << endl;
//	minA_3->setValue(1);
//	    maxA_3->setValue(20);
//	    minB_3->setValue(1);
//	    maxB_3->setValue(10);
//	    addBox->setChecked(true);
//	    subBox->setChecked(true);
//	    multBox->setChecked(false);
//	    divBox->setChecked(false);
//	} --All now void.
    settings.endGroup();
}
