/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include <iostream>
	using namespace std;
#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <string.h>
#include <qstring.h>
#include <qmessagebox.h>
#include <qlineedit.h>
#include <qapplication.h>
#include <qsettings.h>

	
void arithForm::verify()
{
    QSettings scores;
    scores.setPath("corfizz.com",tr("Maths Tester"));
    scores.beginGroup("/Scores");
    int total=scores.readNumEntry("/Scores/total", 0);
    int correct=scores.readNumEntry("/Scores/correct", 0);
    int wrong=scores.readNumEntry("/Scores/wrong", 0);
    int atotal=scores.readNumEntry("/Scores/atotal", 0);
    int acorrect=scores.readNumEntry("/Scores/acorrect", 0);
    int awrong=scores.readNumEntry("/Scores/awrong", 0);
    scores.endGroup();
    if(needToAddToTotal){
	total+=1;
	atotal+=1;
	needToAddToTotal=false;
    }
    QString currentAnswerWritten = answerBox->text();
    bool ok;
    int currentAnswer = currentAnswerWritten.toInt(&ok);
    answerStatus->show();
    if(currentAnswer == (float)x){
	cout << "Correct" << endl;
	answerStatus->setText(tr("Your answer is correct."));
	if (needToAddToCorrect){
	    needToAddToCorrect=false;
	    needToAddToWrong=false;
	    correct+=1;
	    acorrect+=1;
	}
    }
    else
    {
	cout << "Wrong" << endl;
	answerStatus->setText(tr("Your answer is currently incorrect."));
	if(needToAddToWrong){
	    needToAddToWrong=false;
	    needToAddToCorrect=false;
	    wrong+=1;
	    awrong+=1;
	}
    }
    cout << "Saving Scores..." << endl;
    scores.setPath("corfizz.com", tr("Maths Tester"));
    scores.beginGroup("/Scores");
    scores.writeEntry("/Scores/total", total);
    scores.writeEntry("/Scores/correct", correct);
    scores.writeEntry("/Scores/wrong", wrong);
    scores.writeEntry("/Scores/atotal", atotal);
    scores.writeEntry("/Scores/acorrect", acorrect);
    scores.writeEntry("/Scores/awrong", awrong);
    scores.endGroup();
    cout << "Scores Saved" << endl;
    cout << "Score: " << correct << "/" << total << ", so you've got " << wrong << " wrong." << endl;
}


void arithForm::next()
{
    arithForm dialog(this);
    dialog.exec();
}


int rndrange(int lowest_number, int highest_number)
{
  if(lowest_number > highest_number){
      swap(lowest_number, highest_number);
  }
 
   int range = highest_number - lowest_number + 1;
   static const int dummy = (srand((unsigned)time(0)), 0); //this will only get called once

   double rn = rand();
   int extra = range * (double)rn/(RAND_MAX + 1.0);
   return lowest_number + extra;
}


void arithForm::init()
{
    needToAddToTotal=true;
    needToAddToCorrect=true;
    needToAddToWrong=true;
    atotal=acorrect=awrong=0;
    
    QSettings scores;
    scores.setPath("corfizz.com", tr("Maths Tester"));
    scores.beginGroup("/Scores");
    int total=scores.readNumEntry("/Scores/total", 0);
    int correct=scores.readNumEntry("/Scores/correct", 0);
    int wrong=scores.readNumEntry("/Scores/wrong", 0);
    atotal=scores.readNumEntry("/Scores/atotal", 0);
    acorrect=scores.readNumEntry("/Scores/acorrect", 0);
    awrong=scores.readNumEntry("/Scores/awrong", 0);
    scores.endGroup();
    answerStatus->hide();
    
    QSettings settings;
    settings.setPath("corfizz.com", tr("Maths Tester"));
    settings.beginGroup("/Settings");
    int minia = settings.readNumEntry("/Settings/minia", minia);
    int maxia = settings.readNumEntry("/Settings/maxia", maxia);
    int minib = settings.readNumEntry("/Settings/minib", minib);
    int maxib = settings.readNumEntry("/Settings/maxib", maxib);
    bool addop = settings.readBoolEntry("/Settings/addop", addop);
    bool subop = settings.readBoolEntry("/Settings/subop", subop);
    bool multop = settings.readBoolEntry("/Settings/multop", multop);
    bool divop = settings.readBoolEntry("/Settings/divop", divop);
    settings.endGroup();

    cout << "minia: " << minia << " multop: " << multop << endl;
    cout << correct << "/" << total << " Wrong: " << wrong << endl;
    
//    if(minia==minib==maxia==maxib==0){
//	minia=1;
//	    maxia=20;
//	    minib=1;
//	    maxib=10;
//	    addop=true;
//	    subop=true;
//	    multop=false;
//	    divop=false;
//	}
    
    int forbidden=0;
    int decideop=0;

    decideop = rndrange(1,4);
	if(decideop==1 && addop==0){
	    forbidden=1;
	}
	if(decideop==2 && subop==0){
	    forbidden=1;
	}
	if(decideop==3 && multop==0){
	    forbidden=1;
	}
	if(decideop==4 && divop==0){
	    forbidden=1;
	}
	
    if(forbidden==1){
    	decideop = 0;
	decideop = rndrange(1,4);
    }
	
    while(forbidden==1){
	if(decideop==1 && addop==0){
	    forbidden=1;
	    decideop = 0;
	    decideop = rndrange(1,4);
	}
	if(decideop==2 && subop==0){
	    forbidden=1;
	    decideop = 0;
	    decideop = rndrange(1,4);
	}
	if(decideop==3 && multop==0){
	    forbidden=1;
	    decideop = 0;
	    decideop = rndrange(1,4);
	}
	if(decideop==4 && divop==0){
	    forbidden=1;
	    decideop = 0;
	    decideop = rndrange(1,4);
	}
	switch(decideop){
	case 1:
	   if(addop!=0){ forbidden=0; break; }
	   break;
	case 2:
	   if(subop!=0){ forbidden=0; break; }
	   break;
	case 3:
	   if(multop!=0){ forbidden=0; break; }
	   break;
	case 4:
	   if(divop!=0){ forbidden=0; break; }
	   break;
	default:
	   cout << "Slight error..." << endl;
	   }
    }

    float a=0;
    float b=0;
    x=0;
    
    a=rndrange(minia,maxia);
    b=rndrange(minib,maxib);
    QString question;
    QString op;
    
    switch(decideop){
    case 1:
	op=" + ";
	x=a+b;
	break;	
    case 2:
	op=" - ";
	x=a-b;
	break;	
    case 3:
	op=" * ";
	x=a*b;
	break;	
    case 4:
	op=" / ";
	cout << "Division chosen" << endl;
	x=a/b;
	while(((float)x)>(int)x && ((float)x)<((int)x+1)){ a=b=0; a=rndrange(minia,maxia); b=rndrange(minib,maxib); x=a/b; } // makes division question use clean integer division only.
	break;
    default:
	op=" + "; cout << "Slight error 2" << endl;
    }
    
    question=QString::number(a)+op+QString::number(b)+" = ";
    questionLabel->setText(question);
}
