/****************************************************************************
** Form implementation generated from reading ui file 'letForm.ui'
**
** Created: Sat Oct 16 13:38:54 2004
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.3.0   edited Nov 24 13:47 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "letForm.h"

#include <qvariant.h>
#include <qstring.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "letForm.ui.h"

/*
 *  Constructs a letForm as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
letForm::letForm( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "letForm" );
    setPaletteBackgroundColor( QColor( 230, 239, 250 ) );
    letFormLayout = new QGridLayout( this, 1, 1, 11, 6, "letFormLayout"); 
    spacer7 = new QSpacerItem( 20, 20, QSizePolicy::Fixed, QSizePolicy::Minimum );
    letFormLayout->addItem( spacer7, 0, 1 );

    layout11 = new QVBoxLayout( 0, 0, 6, "layout11"); 

    acceptButton = new QPushButton( this, "acceptButton" );
    acceptButton->setDefault( TRUE );
    layout11->addWidget( acceptButton );

    nextButton = new QPushButton( this, "nextButton" );
    layout11->addWidget( nextButton );

    retireButton = new QPushButton( this, "retireButton" );
    layout11->addWidget( retireButton );
    spacer5 = new QSpacerItem( 20, 31, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout11->addItem( spacer5 );

    expButton = new QPushButton( this, "expButton" );
    expButton->setToggleButton( TRUE );
    layout11->addWidget( expButton );

    letFormLayout->addLayout( layout11, 0, 2 );

    layout6 = new QVBoxLayout( 0, 0, 6, "layout6"); 

    textLabel = new QLabel( this, "textLabel" );
    QFont textLabel_font(  textLabel->font() );
    textLabel_font.setPointSize( 14 );
    textLabel->setFont( textLabel_font ); 
    layout6->addWidget( textLabel );

    equation = new QLabel( this, "equation" );
    equation->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)7, 0, 0, equation->sizePolicy().hasHeightForWidth() ) );
    QFont equation_font(  equation->font() );
    equation_font.setFamily( "Times" );
    equation_font.setPointSize( 20 );
    equation->setFont( equation_font ); 
    equation->setAlignment( int( QLabel::AlignCenter ) );
    layout6->addWidget( equation );

    layout13 = new QHBoxLayout( 0, 0, 6, "layout13"); 

    answerLabel = new QLabel( this, "answerLabel" );
    QFont answerLabel_font(  answerLabel->font() );
    answerLabel_font.setPointSize( 14 );
    answerLabel->setFont( answerLabel_font ); 
    answerLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );
    layout13->addWidget( answerLabel );

    answerBox = new QLineEdit( this, "answerBox" );
    QFont answerBox_font(  answerBox->font() );
    answerBox_font.setPointSize( 16 );
    answerBox->setFont( answerBox_font ); 
    answerBox->setFrameShadow( QLineEdit::Sunken );
    answerBox->setMaxLength( 32767 );
    layout13->addWidget( answerBox );
    layout6->addLayout( layout13 );

    answerStatus = new QLabel( this, "answerStatus" );
    layout6->addWidget( answerStatus );
    spacer6 = new QSpacerItem( 20, 42, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout6->addItem( spacer6 );

    letFormLayout->addLayout( layout6, 0, 0 );

    explanation = new QLabel( this, "explanation" );
    explanation->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)7, 0, 0, explanation->sizePolicy().hasHeightForWidth() ) );

    letFormLayout->addWidget( explanation, 1, 0 );
    languageChange();
    resize( QSize(481, 212).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( expButton, SIGNAL( toggled(bool) ), this, SLOT( generateExplanation() ) );
    connect( retireButton, SIGNAL( clicked() ), this, SLOT( close() ) );
    connect( nextButton, SIGNAL( clicked() ), this, SLOT( close() ) );
    connect( nextButton, SIGNAL( clicked() ), this, SLOT( next() ) );
    connect( answerBox, SIGNAL( returnPressed() ), this, SLOT( verify() ) );
    connect( acceptButton, SIGNAL( clicked() ), this, SLOT( verify() ) );
    connect( expButton, SIGNAL( toggled(bool) ), explanation, SLOT( setShown(bool) ) );

    // buddies
    answerLabel->setBuddy( answerBox );
    init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
letForm::~letForm()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void letForm::languageChange()
{
    setCaption( tr( "Linear Equations Tester" ) );
    acceptButton->setText( tr( "&Verify" ) );
    acceptButton->setAccel( QKeySequence( tr( "Alt+V" ) ) );
    nextButton->setText( tr( "&Next" ) );
    nextButton->setAccel( QKeySequence( tr( "Alt+N" ) ) );
    retireButton->setText( tr( "&Retire" ) );
    retireButton->setAccel( QKeySequence( tr( "Alt+R" ) ) );
    expButton->setText( tr( "&Explanation" ) );
    expButton->setAccel( QKeySequence( tr( "Alt+E" ) ) );
    textLabel->setText( tr( "Solve:" ) );
    equation->setText( QString::null );
    QToolTip::add( equation, tr( "What a lovely equation!" ) );
    QWhatsThis::add( equation, tr( "Solve this equation and enter your answer in the box below." ) );
    answerLabel->setText( tr( "x =" ) );
    answerBox->setText( QString::null );
    answerBox->setInputMask( QString::null );
    QToolTip::add( answerBox, tr( "Enter Your Answer Here" ) );
    QWhatsThis::add( answerBox, tr( "This is where you should enter your answer." ) );
    answerStatus->setText( tr( "Your answer is currently incorrect." ) );
    explanation->setText( tr( "Explanation" ) );
}

