/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include <iostream>
	using namespace std;
#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <string.h>
#include <qstring.h>
#include <qmessagebox.h>
#include <qlineedit.h>
#include <qapplication.h>
#include <qsettings.h>

int randomrange(int lowest_number, int highest_number)
{
  if(lowest_number > highest_number){
      swap(lowest_number, highest_number);
  }
 
   int range = highest_number - lowest_number + 1;
   static const int dummy = (srand((unsigned)time(0)), 0); //this will only get called once

   double rn = rand();
   int extra = range * (double)rn/(RAND_MAX + 1.0);
   return lowest_number + extra;
}


void simForm::generateExplanation()
{
    
}


void simForm::next()
{
    simForm dialog(this);
    dialog.exec();
}


void simForm::verify()
{
    QSettings scores;
    scores.setPath("corfizz.com",tr("Maths Tester"));
    scores.beginGroup("/Scores");
    int total=scores.readNumEntry("/Scores/total", 0);
    int correct=scores.readNumEntry("/Scores/correct", 0);
    int wrong=scores.readNumEntry("/Scores/wrong", 0);
    int stotal=scores.readNumEntry("/Scores/stotal", 0);
    int scorrect=scores.readNumEntry("/Scores/scorrect", 0);
    int swrong=scores.readNumEntry("/Scores/swrong",0);
    scores.endGroup();
    if(needToAddToTotal){
	total+=1;
	stotal+=1;
	needToAddToTotal=false;
    }
    QString currentAnswerWritten = answerBox->text();
    QString currentYAnswerWritten = answerBox2->text();
    bool ok;
    bool ok2;
    int currentAnswer = currentAnswerWritten.toInt(&ok);
    int currentYAnswer = currentYAnswerWritten.toInt(&ok2);
    answerStatus->show();
    if(currentAnswer == varx && currentYAnswer == vary){
	cout << "Correct" << endl;
	answerStatus->setText(tr("Your answers are correct."));
	if (needToAddToCorrect){
	    correct+=1;
	    scorrect+=1;
	    needToAddToCorrect=false;
	    needToAddToWrong=false;
	}
    }
    else if(currentAnswer == varx && currentYAnswer != vary)
    {
	cout << "Wrong" << endl;
	answerStatus->setText(tr("Your answer for y is currently incorrect."));
	if(needToAddToWrong){
	    wrong+=1;
	    swrong+=1;
	    needToAddToWrong=false;
	    needToAddToCorrect=false;
	}
    }
    else if(currentAnswer != varx && currentYAnswer == vary){
	cout << "Wrong" << endl;
                answerStatus->setText(tr("Your answer for x is currently incorrect."));
                if(needToAddToWrong){
	    wrong+=1;
	    swrong+=1;
	    needToAddToWrong=false;
	    needToAddToCorrect=false;
	}
	    }
    else {
	cout << "Wrong" << endl;
                answerStatus->setText(tr("Your answers are currently incorrect."));
                if(needToAddToWrong){
	    wrong+=1;
	    swrong+=1;
	    needToAddToWrong=false;
	    needToAddToCorrect=false;
	}
	    }
    cout << "Saving Scores..." << endl;
    scores.setPath("corfizz.com", "Maths Tester");
    scores.beginGroup("/Scores");
    scores.writeEntry("/Scores/total", total);
    scores.writeEntry("/Scores/correct", correct);
    scores.writeEntry("/Scores/wrong", wrong);
    scores.writeEntry("/Scores/stotal", stotal);
    scores.writeEntry("/Scores/scorrect", scorrect);
    scores.writeEntry("/Scores/swrong", swrong);
    scores.endGroup();
    cout << "Scores Saved" << endl;
    cout << "Score: " << scorrect << "/" << stotal << ", so you got " << swrong << " wrong." << endl;
}


void simForm::init()
{
    needToAddToTotal=true;
    needToAddToCorrect=true;
    needToAddToWrong=true;
    QSettings scores;
    scores.setPath("corfizz.com", tr("Maths Tester"));
    scores.beginGroup("/Scores");
    int total=scores.readNumEntry("/Scores/total", 0);
    int correct=scores.readNumEntry("/Scores/correct", 0);
    int wrong=scores.readNumEntry("/Scores/wrong", 0);
    int stotal=scores.readNumEntry("/Scores/stotal", 0);
    int scorrect=scores.readNumEntry("/Scores/scorrect", 0);
    int swrong=scores.readNumEntry("/Scores/swrong",0);
    scores.endGroup();
    explanation->hide();
    answerStatus->hide();
    
    QSettings settings;
    settings.setPath("corfizz.com", tr("Maths Tester"));
    settings.beginGroup("/Settings");
    int minxs = settings.readNumEntry("/Settings/minX2", minxs);
    int minys = settings.readNumEntry("/Settings/minY2", minys);
    int minas = settings.readNumEntry("/Settings/minA2", minas);
    int maxxs = settings.readNumEntry("/Settings/maxX2", maxxs);
    int maxys = settings.readNumEntry("/Settings/maxY2", maxys);
    int maxas = settings.readNumEntry("/Settings/maxA2", maxas);
    expButton->hide();
    adjustSize();
    
    varx=randomrange(minxs,maxxs);
    vary=randomrange(minxs,maxxs);
    varax1=randomrange(minas,maxas);
    varay1=randomrange(minas,maxas);
    varwx1=randomrange(minys,maxys);
    varwx2=randomrange(minys,maxys);
    varax2=randomrange(minas,maxas);
    varay2=randomrange(minas,maxas);
    z=(varx*varax1)+(vary*varay1)+varwx1;
    z2=(varx*varax2)+(vary*varay2)+varwx2;
    QString aon1;
    QString aon2;
    QString aon3;
    QString aon4;
    QString pluson1;
    QString pluson2;
    QString pluson11;
    QString pluson22;
    QString constant1;
    QString constant2;
    if (varax1!=1) {
        aon1 = QString::number(varax1);
    }
    else
    {
        aon1="";
    }
    if (varay1!=1) {
        aon2 = QString::number(varay1);
    }
    else
    {
        aon2="";
    }
    if (varax2!=1) {
        aon3 = QString::number(varax2);
    }
    else
    {
        aon3="";
    }
    if (varay2!=1) {
        aon4 = QString::number(varay2);
    }
    else
    {
        aon4="";
    }
    if (varwx1<1) {
        pluson1=" ";
    }
    else
    {
        pluson1=" + ";
    }
    if (varwx2<1) {
        pluson2=" ";
    }
    else
    {
        pluson2=" + ";
    }
    if (varay1<1) {
        pluson11=" ";
    }
    else
    {
        pluson11=" + ";
    }
    if (varay2<1) {
        pluson22=" ";
    }
    else
    {
        pluson22=" + ";
    }
    if (varwx1==0){
	constant1="";
    }
    else {
	constant1=QString::number(varwx1);
}
    if (varwx2==0){
	constant2=="";
    }
    else {
	constant2=QString::number(varwx2);
    }
    QString sim=aon1+"x"+pluson11+aon2+"y"+pluson1+constant1+" = "+QString::number(z)+"\n"+aon3+"x "+pluson22+aon4+"y"+pluson2+constant2+" = "+QString::number(z2);
    equation->setText(sim);
    QString currentAnswer;
    currentAnswer = answerBox->displayText();
    settings.endGroup();
}
